// Code generated by protoc-gen-twirp v5.12.1, DO NOT EDIT.
// source: code.justin.tv/amzn/TwitchSafetyLowTrustUsersTwirp/twirp.proto

/*
Package TwitchSafetyLowTrustUsersTwirp is a generated twirp stub package.
This code was generated with github.com/twitchtv/twirp/protoc-gen-twirp v5.12.1.

It is generated from these files:
	code.justin.tv/amzn/TwitchSafetyLowTrustUsersTwirp/bansInfoSharing.proto
	code.justin.tv/amzn/TwitchSafetyLowTrustUsersTwirp/lowTrustUserSettings.proto
	code.justin.tv/amzn/TwitchSafetyLowTrustUsersTwirp/lowTrustUsers.proto
	code.justin.tv/amzn/TwitchSafetyLowTrustUsersTwirp/twirp.proto
*/
package TwitchSafetyLowTrustUsersTwirp

import bytes "bytes"
import strings "strings"
import context "context"
import fmt "fmt"
import ioutil "io/ioutil"
import http "net/http"
import strconv "strconv"

import jsonpb "github.com/golang/protobuf/jsonpb"
import proto "github.com/golang/protobuf/proto"
import twirp "github.com/twitchtv/twirp"
import ctxsetters "github.com/twitchtv/twirp/ctxsetters"

// Imports only used by utility functions:
import io "io"
import json "encoding/json"
import url "net/url"

// ===================================
// TwitchSafetyLowTrustUsers Interface
// ===================================

type TwitchSafetyLowTrustUsers interface {
	// Enforces the ban evading user based on the message sent in a chat room
	EnforceLowTrustUserMessage(context.Context, *EnforceLowTrustUserMessageRequest) (*EnforceLowTrustUserMessageResponse, error)

	// Evaluates a user's ban evader status.
	EvaluateTrustStatus(context.Context, *EvaluateTrustStatusRequest) (*EvaluateTrustStatusResponse, error)

	// Retrieves information on a previously evaluated user if they exist.
	GetLowTrustUserProperties(context.Context, *GetLowTrustUserPropertiesRequest) (*GetLowTrustUserPropertiesResponse, error)

	// Creates/Updates a low trust user with moderator treatments.
	UpdateLowTrustUserTreatment(context.Context, *UpdateLowTrustUserTreatmentRequest) (*UpdateLowTrustUserTreatmentResponse, error)

	// Force updates a user to a state in which they are marked as a ban evader with a given likelihood - *should be used only for testing purposes*
	ForceUpdateLowTrustUserEvaluation(context.Context, *ForceUpdateLowTrustUserEvaluationRequest) (*ForceUpdateLowTrustUserEvaluationResponse, error)

	// Deletes all LowTrustUser settings for a channel.
	DeleteLowTrustUsersSettings(context.Context, *DeleteLowTrustUsersSettingsRequest) (*DeleteLowTrustUsersSettingsResponse, error)

	// Delete the low trust user evaluation on a channel. Reserved for integration tests only
	DeleteLowTrustUser(context.Context, *DeleteLowTrustUserRequest) (*DeleteLowTrustUserResponse, error)

	// Creates/Updates the ban evasion detection settings for a channel.
	SetBanEvasionDetectionSettings(context.Context, *SetBanEvasionDetectionSettingsRequest) (*SetBanEvasionDetectionSettingsResponse, error)

	// Retrieves information about a channel’s ban evasion detection settings.
	GetBanEvasionDetectionSettings(context.Context, *GetBanEvasionDetectionSettingsRequest) (*GetBanEvasionDetectionSettingsResponse, error)

	// Update bans sharing settings by enabling it and adding all the specified permissions.
	EnableBansSharing(context.Context, *EnableBansSharingRequest) (*EnableBansSharingResponse, error)

	// Update bans sharing settings by disabling it and clearing all permissions.
	DisableBansSharing(context.Context, *DisableBansSharingRequest) (*DisableBansSharingResponse, error)

	// Retrieves bans sharing settings.
	GetBansSharingSettings(context.Context, *GetBansSharingSettingsRequest) (*GetBansSharingSettingsResponse, error)

	// Creates a new bans sharing request from one user to another.
	CreateBansSharingRequests(context.Context, *CreateBansSharingRequestsRequest) (*CreateBansSharingRequestsResponse, error)

	// Deletes requests and active relationships for a channel.
	DeleteBansSharingRequests(context.Context, *DeleteBansSharingRequestsRequest) (*DeleteBansSharingRequestsResponse, error)

	// Retrieves all active relationships for a channel.
	GetExistingBansSharingRelationshipsForChannel(context.Context, *GetExistingBansSharingRelationshipsForChannelRequest) (*GetExistingBansSharingRelationshipsForChannelResponse, error)

	// Retrieves all pending bans sharing requests from a channel.
	GetPendingBansSharingRequestsFromChannel(context.Context, *GetPendingBansSharingRequestsFromChannelRequest) (*GetPendingBansSharingRequestsFromChannelResponse, error)

	// Retrieves all pending bans sharing requests to a channel with pagination.
	GetPendingBansSharingRequestsToChannel(context.Context, *GetPendingBansSharingRequestsToChannelRequest) (*GetPendingBansSharingRequestsToChannelResponse, error)
}

// =========================================
// TwitchSafetyLowTrustUsers Protobuf Client
// =========================================

type twitchSafetyLowTrustUsersProtobufClient struct {
	client HTTPClient
	urls   [17]string
	opts   twirp.ClientOptions
}

// NewTwitchSafetyLowTrustUsersProtobufClient creates a Protobuf client that implements the TwitchSafetyLowTrustUsers interface.
// It communicates using Protobuf and can be configured with a custom HTTPClient.
func NewTwitchSafetyLowTrustUsersProtobufClient(addr string, client HTTPClient, opts ...twirp.ClientOption) TwitchSafetyLowTrustUsers {
	if c, ok := client.(*http.Client); ok {
		client = withoutRedirects(c)
	}

	clientOpts := twirp.ClientOptions{}
	for _, o := range opts {
		o(&clientOpts)
	}

	prefix := urlBase(addr) + TwitchSafetyLowTrustUsersPathPrefix
	urls := [17]string{
		prefix + "EnforceLowTrustUserMessage",
		prefix + "EvaluateTrustStatus",
		prefix + "GetLowTrustUserProperties",
		prefix + "UpdateLowTrustUserTreatment",
		prefix + "ForceUpdateLowTrustUserEvaluation",
		prefix + "DeleteLowTrustUsersSettings",
		prefix + "DeleteLowTrustUser",
		prefix + "SetBanEvasionDetectionSettings",
		prefix + "GetBanEvasionDetectionSettings",
		prefix + "EnableBansSharing",
		prefix + "DisableBansSharing",
		prefix + "GetBansSharingSettings",
		prefix + "CreateBansSharingRequests",
		prefix + "DeleteBansSharingRequests",
		prefix + "GetExistingBansSharingRelationshipsForChannel",
		prefix + "GetPendingBansSharingRequestsFromChannel",
		prefix + "GetPendingBansSharingRequestsToChannel",
	}

	return &twitchSafetyLowTrustUsersProtobufClient{
		client: client,
		urls:   urls,
		opts:   clientOpts,
	}
}

func (c *twitchSafetyLowTrustUsersProtobufClient) EnforceLowTrustUserMessage(ctx context.Context, in *EnforceLowTrustUserMessageRequest) (*EnforceLowTrustUserMessageResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "EnforceLowTrustUserMessage")
	out := new(EnforceLowTrustUserMessageResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[0], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) EvaluateTrustStatus(ctx context.Context, in *EvaluateTrustStatusRequest) (*EvaluateTrustStatusResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "EvaluateTrustStatus")
	out := new(EvaluateTrustStatusResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[1], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) GetLowTrustUserProperties(ctx context.Context, in *GetLowTrustUserPropertiesRequest) (*GetLowTrustUserPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetLowTrustUserProperties")
	out := new(GetLowTrustUserPropertiesResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[2], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) UpdateLowTrustUserTreatment(ctx context.Context, in *UpdateLowTrustUserTreatmentRequest) (*UpdateLowTrustUserTreatmentResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "UpdateLowTrustUserTreatment")
	out := new(UpdateLowTrustUserTreatmentResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[3], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) ForceUpdateLowTrustUserEvaluation(ctx context.Context, in *ForceUpdateLowTrustUserEvaluationRequest) (*ForceUpdateLowTrustUserEvaluationResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "ForceUpdateLowTrustUserEvaluation")
	out := new(ForceUpdateLowTrustUserEvaluationResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[4], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) DeleteLowTrustUsersSettings(ctx context.Context, in *DeleteLowTrustUsersSettingsRequest) (*DeleteLowTrustUsersSettingsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteLowTrustUsersSettings")
	out := new(DeleteLowTrustUsersSettingsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[5], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) DeleteLowTrustUser(ctx context.Context, in *DeleteLowTrustUserRequest) (*DeleteLowTrustUserResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteLowTrustUser")
	out := new(DeleteLowTrustUserResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[6], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) SetBanEvasionDetectionSettings(ctx context.Context, in *SetBanEvasionDetectionSettingsRequest) (*SetBanEvasionDetectionSettingsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "SetBanEvasionDetectionSettings")
	out := new(SetBanEvasionDetectionSettingsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[7], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) GetBanEvasionDetectionSettings(ctx context.Context, in *GetBanEvasionDetectionSettingsRequest) (*GetBanEvasionDetectionSettingsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetBanEvasionDetectionSettings")
	out := new(GetBanEvasionDetectionSettingsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[8], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) EnableBansSharing(ctx context.Context, in *EnableBansSharingRequest) (*EnableBansSharingResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "EnableBansSharing")
	out := new(EnableBansSharingResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[9], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) DisableBansSharing(ctx context.Context, in *DisableBansSharingRequest) (*DisableBansSharingResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "DisableBansSharing")
	out := new(DisableBansSharingResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[10], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) GetBansSharingSettings(ctx context.Context, in *GetBansSharingSettingsRequest) (*GetBansSharingSettingsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetBansSharingSettings")
	out := new(GetBansSharingSettingsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[11], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) CreateBansSharingRequests(ctx context.Context, in *CreateBansSharingRequestsRequest) (*CreateBansSharingRequestsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "CreateBansSharingRequests")
	out := new(CreateBansSharingRequestsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[12], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) DeleteBansSharingRequests(ctx context.Context, in *DeleteBansSharingRequestsRequest) (*DeleteBansSharingRequestsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteBansSharingRequests")
	out := new(DeleteBansSharingRequestsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[13], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) GetExistingBansSharingRelationshipsForChannel(ctx context.Context, in *GetExistingBansSharingRelationshipsForChannelRequest) (*GetExistingBansSharingRelationshipsForChannelResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetExistingBansSharingRelationshipsForChannel")
	out := new(GetExistingBansSharingRelationshipsForChannelResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[14], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) GetPendingBansSharingRequestsFromChannel(ctx context.Context, in *GetPendingBansSharingRequestsFromChannelRequest) (*GetPendingBansSharingRequestsFromChannelResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetPendingBansSharingRequestsFromChannel")
	out := new(GetPendingBansSharingRequestsFromChannelResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[15], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersProtobufClient) GetPendingBansSharingRequestsToChannel(ctx context.Context, in *GetPendingBansSharingRequestsToChannelRequest) (*GetPendingBansSharingRequestsToChannelResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetPendingBansSharingRequestsToChannel")
	out := new(GetPendingBansSharingRequestsToChannelResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[16], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

// =====================================
// TwitchSafetyLowTrustUsers JSON Client
// =====================================

type twitchSafetyLowTrustUsersJSONClient struct {
	client HTTPClient
	urls   [17]string
	opts   twirp.ClientOptions
}

// NewTwitchSafetyLowTrustUsersJSONClient creates a JSON client that implements the TwitchSafetyLowTrustUsers interface.
// It communicates using JSON and can be configured with a custom HTTPClient.
func NewTwitchSafetyLowTrustUsersJSONClient(addr string, client HTTPClient, opts ...twirp.ClientOption) TwitchSafetyLowTrustUsers {
	if c, ok := client.(*http.Client); ok {
		client = withoutRedirects(c)
	}

	clientOpts := twirp.ClientOptions{}
	for _, o := range opts {
		o(&clientOpts)
	}

	prefix := urlBase(addr) + TwitchSafetyLowTrustUsersPathPrefix
	urls := [17]string{
		prefix + "EnforceLowTrustUserMessage",
		prefix + "EvaluateTrustStatus",
		prefix + "GetLowTrustUserProperties",
		prefix + "UpdateLowTrustUserTreatment",
		prefix + "ForceUpdateLowTrustUserEvaluation",
		prefix + "DeleteLowTrustUsersSettings",
		prefix + "DeleteLowTrustUser",
		prefix + "SetBanEvasionDetectionSettings",
		prefix + "GetBanEvasionDetectionSettings",
		prefix + "EnableBansSharing",
		prefix + "DisableBansSharing",
		prefix + "GetBansSharingSettings",
		prefix + "CreateBansSharingRequests",
		prefix + "DeleteBansSharingRequests",
		prefix + "GetExistingBansSharingRelationshipsForChannel",
		prefix + "GetPendingBansSharingRequestsFromChannel",
		prefix + "GetPendingBansSharingRequestsToChannel",
	}

	return &twitchSafetyLowTrustUsersJSONClient{
		client: client,
		urls:   urls,
		opts:   clientOpts,
	}
}

func (c *twitchSafetyLowTrustUsersJSONClient) EnforceLowTrustUserMessage(ctx context.Context, in *EnforceLowTrustUserMessageRequest) (*EnforceLowTrustUserMessageResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "EnforceLowTrustUserMessage")
	out := new(EnforceLowTrustUserMessageResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[0], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) EvaluateTrustStatus(ctx context.Context, in *EvaluateTrustStatusRequest) (*EvaluateTrustStatusResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "EvaluateTrustStatus")
	out := new(EvaluateTrustStatusResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[1], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) GetLowTrustUserProperties(ctx context.Context, in *GetLowTrustUserPropertiesRequest) (*GetLowTrustUserPropertiesResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetLowTrustUserProperties")
	out := new(GetLowTrustUserPropertiesResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[2], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) UpdateLowTrustUserTreatment(ctx context.Context, in *UpdateLowTrustUserTreatmentRequest) (*UpdateLowTrustUserTreatmentResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "UpdateLowTrustUserTreatment")
	out := new(UpdateLowTrustUserTreatmentResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[3], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) ForceUpdateLowTrustUserEvaluation(ctx context.Context, in *ForceUpdateLowTrustUserEvaluationRequest) (*ForceUpdateLowTrustUserEvaluationResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "ForceUpdateLowTrustUserEvaluation")
	out := new(ForceUpdateLowTrustUserEvaluationResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[4], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) DeleteLowTrustUsersSettings(ctx context.Context, in *DeleteLowTrustUsersSettingsRequest) (*DeleteLowTrustUsersSettingsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteLowTrustUsersSettings")
	out := new(DeleteLowTrustUsersSettingsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[5], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) DeleteLowTrustUser(ctx context.Context, in *DeleteLowTrustUserRequest) (*DeleteLowTrustUserResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteLowTrustUser")
	out := new(DeleteLowTrustUserResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[6], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) SetBanEvasionDetectionSettings(ctx context.Context, in *SetBanEvasionDetectionSettingsRequest) (*SetBanEvasionDetectionSettingsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "SetBanEvasionDetectionSettings")
	out := new(SetBanEvasionDetectionSettingsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[7], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) GetBanEvasionDetectionSettings(ctx context.Context, in *GetBanEvasionDetectionSettingsRequest) (*GetBanEvasionDetectionSettingsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetBanEvasionDetectionSettings")
	out := new(GetBanEvasionDetectionSettingsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[8], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) EnableBansSharing(ctx context.Context, in *EnableBansSharingRequest) (*EnableBansSharingResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "EnableBansSharing")
	out := new(EnableBansSharingResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[9], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) DisableBansSharing(ctx context.Context, in *DisableBansSharingRequest) (*DisableBansSharingResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "DisableBansSharing")
	out := new(DisableBansSharingResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[10], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) GetBansSharingSettings(ctx context.Context, in *GetBansSharingSettingsRequest) (*GetBansSharingSettingsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetBansSharingSettings")
	out := new(GetBansSharingSettingsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[11], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) CreateBansSharingRequests(ctx context.Context, in *CreateBansSharingRequestsRequest) (*CreateBansSharingRequestsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "CreateBansSharingRequests")
	out := new(CreateBansSharingRequestsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[12], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) DeleteBansSharingRequests(ctx context.Context, in *DeleteBansSharingRequestsRequest) (*DeleteBansSharingRequestsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteBansSharingRequests")
	out := new(DeleteBansSharingRequestsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[13], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) GetExistingBansSharingRelationshipsForChannel(ctx context.Context, in *GetExistingBansSharingRelationshipsForChannelRequest) (*GetExistingBansSharingRelationshipsForChannelResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetExistingBansSharingRelationshipsForChannel")
	out := new(GetExistingBansSharingRelationshipsForChannelResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[14], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) GetPendingBansSharingRequestsFromChannel(ctx context.Context, in *GetPendingBansSharingRequestsFromChannelRequest) (*GetPendingBansSharingRequestsFromChannelResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetPendingBansSharingRequestsFromChannel")
	out := new(GetPendingBansSharingRequestsFromChannelResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[15], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *twitchSafetyLowTrustUsersJSONClient) GetPendingBansSharingRequestsToChannel(ctx context.Context, in *GetPendingBansSharingRequestsToChannelRequest) (*GetPendingBansSharingRequestsToChannelResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithMethodName(ctx, "GetPendingBansSharingRequestsToChannel")
	out := new(GetPendingBansSharingRequestsToChannelResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[16], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

// ========================================
// TwitchSafetyLowTrustUsers Server Handler
// ========================================

type twitchSafetyLowTrustUsersServer struct {
	TwitchSafetyLowTrustUsers
	hooks *twirp.ServerHooks
}

func NewTwitchSafetyLowTrustUsersServer(svc TwitchSafetyLowTrustUsers, hooks *twirp.ServerHooks) TwirpServer {
	return &twitchSafetyLowTrustUsersServer{
		TwitchSafetyLowTrustUsers: svc,
		hooks:                     hooks,
	}
}

// writeError writes an HTTP response with a valid Twirp error format, and triggers hooks.
// If err is not a twirp.Error, it will get wrapped with twirp.InternalErrorWith(err)
func (s *twitchSafetyLowTrustUsersServer) writeError(ctx context.Context, resp http.ResponseWriter, err error) {
	writeError(ctx, resp, err, s.hooks)
}

// TwitchSafetyLowTrustUsersPathPrefix is used for all URL paths on a twirp TwitchSafetyLowTrustUsers server.
// Requests are always: POST TwitchSafetyLowTrustUsersPathPrefix/method
// It can be used in an HTTP mux to route twirp requests along with non-twirp requests on other routes.
const TwitchSafetyLowTrustUsersPathPrefix = "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/"

func (s *twitchSafetyLowTrustUsersServer) ServeHTTP(resp http.ResponseWriter, req *http.Request) {
	ctx := req.Context()
	ctx = ctxsetters.WithPackageName(ctx, "twitch.channelmoderation.twitchsafetylowtrustusers")
	ctx = ctxsetters.WithServiceName(ctx, "TwitchSafetyLowTrustUsers")
	ctx = ctxsetters.WithResponseWriter(ctx, resp)

	var err error
	ctx, err = callRequestReceived(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	if req.Method != "POST" {
		msg := fmt.Sprintf("unsupported method %q (only POST is allowed)", req.Method)
		err = badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, err)
		return
	}

	switch req.URL.Path {
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/EnforceLowTrustUserMessage":
		s.serveEnforceLowTrustUserMessage(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/EvaluateTrustStatus":
		s.serveEvaluateTrustStatus(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/GetLowTrustUserProperties":
		s.serveGetLowTrustUserProperties(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/UpdateLowTrustUserTreatment":
		s.serveUpdateLowTrustUserTreatment(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/ForceUpdateLowTrustUserEvaluation":
		s.serveForceUpdateLowTrustUserEvaluation(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/DeleteLowTrustUsersSettings":
		s.serveDeleteLowTrustUsersSettings(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/DeleteLowTrustUser":
		s.serveDeleteLowTrustUser(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/SetBanEvasionDetectionSettings":
		s.serveSetBanEvasionDetectionSettings(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/GetBanEvasionDetectionSettings":
		s.serveGetBanEvasionDetectionSettings(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/EnableBansSharing":
		s.serveEnableBansSharing(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/DisableBansSharing":
		s.serveDisableBansSharing(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/GetBansSharingSettings":
		s.serveGetBansSharingSettings(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/CreateBansSharingRequests":
		s.serveCreateBansSharingRequests(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/DeleteBansSharingRequests":
		s.serveDeleteBansSharingRequests(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/GetExistingBansSharingRelationshipsForChannel":
		s.serveGetExistingBansSharingRelationshipsForChannel(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/GetPendingBansSharingRequestsFromChannel":
		s.serveGetPendingBansSharingRequestsFromChannel(ctx, resp, req)
		return
	case "/twirp/twitch.channelmoderation.twitchsafetylowtrustusers.TwitchSafetyLowTrustUsers/GetPendingBansSharingRequestsToChannel":
		s.serveGetPendingBansSharingRequestsToChannel(ctx, resp, req)
		return
	default:
		msg := fmt.Sprintf("no handler for path %q", req.URL.Path)
		err = badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, err)
		return
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveEnforceLowTrustUserMessage(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveEnforceLowTrustUserMessageJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveEnforceLowTrustUserMessageProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveEnforceLowTrustUserMessageJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EnforceLowTrustUserMessage")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(EnforceLowTrustUserMessageRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EnforceLowTrustUserMessageResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.EnforceLowTrustUserMessage(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EnforceLowTrustUserMessageResponse and nil error while calling EnforceLowTrustUserMessage. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveEnforceLowTrustUserMessageProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EnforceLowTrustUserMessage")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(EnforceLowTrustUserMessageRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EnforceLowTrustUserMessageResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.EnforceLowTrustUserMessage(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EnforceLowTrustUserMessageResponse and nil error while calling EnforceLowTrustUserMessage. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveEvaluateTrustStatus(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveEvaluateTrustStatusJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveEvaluateTrustStatusProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveEvaluateTrustStatusJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EvaluateTrustStatus")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(EvaluateTrustStatusRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EvaluateTrustStatusResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.EvaluateTrustStatus(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EvaluateTrustStatusResponse and nil error while calling EvaluateTrustStatus. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveEvaluateTrustStatusProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EvaluateTrustStatus")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(EvaluateTrustStatusRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EvaluateTrustStatusResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.EvaluateTrustStatus(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EvaluateTrustStatusResponse and nil error while calling EvaluateTrustStatus. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetLowTrustUserProperties(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetLowTrustUserPropertiesJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetLowTrustUserPropertiesProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveGetLowTrustUserPropertiesJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetLowTrustUserProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetLowTrustUserPropertiesRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetLowTrustUserPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetLowTrustUserProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetLowTrustUserPropertiesResponse and nil error while calling GetLowTrustUserProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetLowTrustUserPropertiesProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetLowTrustUserProperties")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetLowTrustUserPropertiesRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetLowTrustUserPropertiesResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetLowTrustUserProperties(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetLowTrustUserPropertiesResponse and nil error while calling GetLowTrustUserProperties. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveUpdateLowTrustUserTreatment(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveUpdateLowTrustUserTreatmentJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveUpdateLowTrustUserTreatmentProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveUpdateLowTrustUserTreatmentJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "UpdateLowTrustUserTreatment")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(UpdateLowTrustUserTreatmentRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *UpdateLowTrustUserTreatmentResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.UpdateLowTrustUserTreatment(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *UpdateLowTrustUserTreatmentResponse and nil error while calling UpdateLowTrustUserTreatment. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveUpdateLowTrustUserTreatmentProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "UpdateLowTrustUserTreatment")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(UpdateLowTrustUserTreatmentRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *UpdateLowTrustUserTreatmentResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.UpdateLowTrustUserTreatment(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *UpdateLowTrustUserTreatmentResponse and nil error while calling UpdateLowTrustUserTreatment. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveForceUpdateLowTrustUserEvaluation(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveForceUpdateLowTrustUserEvaluationJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveForceUpdateLowTrustUserEvaluationProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveForceUpdateLowTrustUserEvaluationJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ForceUpdateLowTrustUserEvaluation")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(ForceUpdateLowTrustUserEvaluationRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ForceUpdateLowTrustUserEvaluationResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.ForceUpdateLowTrustUserEvaluation(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ForceUpdateLowTrustUserEvaluationResponse and nil error while calling ForceUpdateLowTrustUserEvaluation. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveForceUpdateLowTrustUserEvaluationProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ForceUpdateLowTrustUserEvaluation")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(ForceUpdateLowTrustUserEvaluationRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *ForceUpdateLowTrustUserEvaluationResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.ForceUpdateLowTrustUserEvaluation(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ForceUpdateLowTrustUserEvaluationResponse and nil error while calling ForceUpdateLowTrustUserEvaluation. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteLowTrustUsersSettings(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteLowTrustUsersSettingsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteLowTrustUsersSettingsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteLowTrustUsersSettingsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteLowTrustUsersSettings")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DeleteLowTrustUsersSettingsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteLowTrustUsersSettingsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.DeleteLowTrustUsersSettings(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteLowTrustUsersSettingsResponse and nil error while calling DeleteLowTrustUsersSettings. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteLowTrustUsersSettingsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteLowTrustUsersSettings")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DeleteLowTrustUsersSettingsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteLowTrustUsersSettingsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.DeleteLowTrustUsersSettings(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteLowTrustUsersSettingsResponse and nil error while calling DeleteLowTrustUsersSettings. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteLowTrustUser(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteLowTrustUserJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteLowTrustUserProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteLowTrustUserJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteLowTrustUser")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DeleteLowTrustUserRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteLowTrustUserResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.DeleteLowTrustUser(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteLowTrustUserResponse and nil error while calling DeleteLowTrustUser. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteLowTrustUserProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteLowTrustUser")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DeleteLowTrustUserRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteLowTrustUserResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.DeleteLowTrustUser(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteLowTrustUserResponse and nil error while calling DeleteLowTrustUser. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveSetBanEvasionDetectionSettings(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveSetBanEvasionDetectionSettingsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveSetBanEvasionDetectionSettingsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveSetBanEvasionDetectionSettingsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "SetBanEvasionDetectionSettings")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(SetBanEvasionDetectionSettingsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *SetBanEvasionDetectionSettingsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.SetBanEvasionDetectionSettings(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *SetBanEvasionDetectionSettingsResponse and nil error while calling SetBanEvasionDetectionSettings. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveSetBanEvasionDetectionSettingsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "SetBanEvasionDetectionSettings")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(SetBanEvasionDetectionSettingsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *SetBanEvasionDetectionSettingsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.SetBanEvasionDetectionSettings(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *SetBanEvasionDetectionSettingsResponse and nil error while calling SetBanEvasionDetectionSettings. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetBanEvasionDetectionSettings(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetBanEvasionDetectionSettingsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetBanEvasionDetectionSettingsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveGetBanEvasionDetectionSettingsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetBanEvasionDetectionSettings")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetBanEvasionDetectionSettingsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetBanEvasionDetectionSettingsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetBanEvasionDetectionSettings(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetBanEvasionDetectionSettingsResponse and nil error while calling GetBanEvasionDetectionSettings. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetBanEvasionDetectionSettingsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetBanEvasionDetectionSettings")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetBanEvasionDetectionSettingsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetBanEvasionDetectionSettingsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetBanEvasionDetectionSettings(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetBanEvasionDetectionSettingsResponse and nil error while calling GetBanEvasionDetectionSettings. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveEnableBansSharing(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveEnableBansSharingJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveEnableBansSharingProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveEnableBansSharingJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EnableBansSharing")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(EnableBansSharingRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EnableBansSharingResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.EnableBansSharing(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EnableBansSharingResponse and nil error while calling EnableBansSharing. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveEnableBansSharingProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "EnableBansSharing")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(EnableBansSharingRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *EnableBansSharingResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.EnableBansSharing(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *EnableBansSharingResponse and nil error while calling EnableBansSharing. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveDisableBansSharing(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDisableBansSharingJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDisableBansSharingProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveDisableBansSharingJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DisableBansSharing")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DisableBansSharingRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DisableBansSharingResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.DisableBansSharing(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DisableBansSharingResponse and nil error while calling DisableBansSharing. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveDisableBansSharingProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DisableBansSharing")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DisableBansSharingRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DisableBansSharingResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.DisableBansSharing(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DisableBansSharingResponse and nil error while calling DisableBansSharing. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetBansSharingSettings(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetBansSharingSettingsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetBansSharingSettingsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveGetBansSharingSettingsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetBansSharingSettings")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetBansSharingSettingsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetBansSharingSettingsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetBansSharingSettings(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetBansSharingSettingsResponse and nil error while calling GetBansSharingSettings. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetBansSharingSettingsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetBansSharingSettings")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetBansSharingSettingsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetBansSharingSettingsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetBansSharingSettings(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetBansSharingSettingsResponse and nil error while calling GetBansSharingSettings. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveCreateBansSharingRequests(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveCreateBansSharingRequestsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveCreateBansSharingRequestsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveCreateBansSharingRequestsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "CreateBansSharingRequests")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(CreateBansSharingRequestsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *CreateBansSharingRequestsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.CreateBansSharingRequests(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *CreateBansSharingRequestsResponse and nil error while calling CreateBansSharingRequests. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveCreateBansSharingRequestsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "CreateBansSharingRequests")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(CreateBansSharingRequestsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *CreateBansSharingRequestsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.CreateBansSharingRequests(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *CreateBansSharingRequestsResponse and nil error while calling CreateBansSharingRequests. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteBansSharingRequests(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteBansSharingRequestsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteBansSharingRequestsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteBansSharingRequestsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteBansSharingRequests")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(DeleteBansSharingRequestsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteBansSharingRequestsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.DeleteBansSharingRequests(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteBansSharingRequestsResponse and nil error while calling DeleteBansSharingRequests. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveDeleteBansSharingRequestsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteBansSharingRequests")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(DeleteBansSharingRequestsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *DeleteBansSharingRequestsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.DeleteBansSharingRequests(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *DeleteBansSharingRequestsResponse and nil error while calling DeleteBansSharingRequests. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetExistingBansSharingRelationshipsForChannel(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetExistingBansSharingRelationshipsForChannelJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetExistingBansSharingRelationshipsForChannelProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveGetExistingBansSharingRelationshipsForChannelJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetExistingBansSharingRelationshipsForChannel")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetExistingBansSharingRelationshipsForChannelRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetExistingBansSharingRelationshipsForChannelResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetExistingBansSharingRelationshipsForChannel(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetExistingBansSharingRelationshipsForChannelResponse and nil error while calling GetExistingBansSharingRelationshipsForChannel. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetExistingBansSharingRelationshipsForChannelProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetExistingBansSharingRelationshipsForChannel")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetExistingBansSharingRelationshipsForChannelRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetExistingBansSharingRelationshipsForChannelResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetExistingBansSharingRelationshipsForChannel(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetExistingBansSharingRelationshipsForChannelResponse and nil error while calling GetExistingBansSharingRelationshipsForChannel. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetPendingBansSharingRequestsFromChannel(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetPendingBansSharingRequestsFromChannelJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetPendingBansSharingRequestsFromChannelProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveGetPendingBansSharingRequestsFromChannelJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetPendingBansSharingRequestsFromChannel")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetPendingBansSharingRequestsFromChannelRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetPendingBansSharingRequestsFromChannelResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetPendingBansSharingRequestsFromChannel(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetPendingBansSharingRequestsFromChannelResponse and nil error while calling GetPendingBansSharingRequestsFromChannel. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetPendingBansSharingRequestsFromChannelProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetPendingBansSharingRequestsFromChannel")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetPendingBansSharingRequestsFromChannelRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetPendingBansSharingRequestsFromChannelResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetPendingBansSharingRequestsFromChannel(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetPendingBansSharingRequestsFromChannelResponse and nil error while calling GetPendingBansSharingRequestsFromChannel. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetPendingBansSharingRequestsToChannel(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveGetPendingBansSharingRequestsToChannelJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveGetPendingBansSharingRequestsToChannelProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *twitchSafetyLowTrustUsersServer) serveGetPendingBansSharingRequestsToChannelJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetPendingBansSharingRequestsToChannel")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(GetPendingBansSharingRequestsToChannelRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetPendingBansSharingRequestsToChannelResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetPendingBansSharingRequestsToChannel(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetPendingBansSharingRequestsToChannelResponse and nil error while calling GetPendingBansSharingRequestsToChannel. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) serveGetPendingBansSharingRequestsToChannelProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "GetPendingBansSharingRequestsToChannel")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(GetPendingBansSharingRequestsToChannelRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	// Call service method
	var respContent *GetPendingBansSharingRequestsToChannelResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = s.TwitchSafetyLowTrustUsers.GetPendingBansSharingRequestsToChannel(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *GetPendingBansSharingRequestsToChannelResponse and nil error while calling GetPendingBansSharingRequestsToChannel. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *twitchSafetyLowTrustUsersServer) ServiceDescriptor() ([]byte, int) {
	return twirpFileDescriptor0, 0
}

func (s *twitchSafetyLowTrustUsersServer) ProtocGenTwirpVersion() string {
	return "v5.12.1"
}

func (s *twitchSafetyLowTrustUsersServer) PathPrefix() string {
	return TwitchSafetyLowTrustUsersPathPrefix
}

// =====
// Utils
// =====

// HTTPClient is the interface used by generated clients to send HTTP requests.
// It is fulfilled by *(net/http).Client, which is sufficient for most users.
// Users can provide their own implementation for special retry policies.
//
// HTTPClient implementations should not follow redirects. Redirects are
// automatically disabled if *(net/http).Client is passed to client
// constructors. See the withoutRedirects function in this file for more
// details.
type HTTPClient interface {
	Do(req *http.Request) (*http.Response, error)
}

// TwirpServer is the interface generated server structs will support: they're
// HTTP handlers with additional methods for accessing metadata about the
// service. Those accessors are a low-level API for building reflection tools.
// Most people can think of TwirpServers as just http.Handlers.
type TwirpServer interface {
	http.Handler
	// ServiceDescriptor returns gzipped bytes describing the .proto file that
	// this service was generated from. Once unzipped, the bytes can be
	// unmarshalled as a
	// github.com/golang/protobuf/protoc-gen-go/descriptor.FileDescriptorProto.
	//
	// The returned integer is the index of this particular service within that
	// FileDescriptorProto's 'Service' slice of ServiceDescriptorProtos. This is a
	// low-level field, expected to be used for reflection.
	ServiceDescriptor() ([]byte, int)
	// ProtocGenTwirpVersion is the semantic version string of the version of
	// twirp used to generate this file.
	ProtocGenTwirpVersion() string
	// PathPrefix returns the HTTP URL path prefix for all methods handled by this
	// service. This can be used with an HTTP mux to route twirp requests
	// alongside non-twirp requests on one HTTP listener.
	PathPrefix() string
}

// WriteError writes an HTTP response with a valid Twirp error format (code, msg, meta).
// Useful outside of the Twirp server (e.g. http middleware), but does not trigger hooks.
// If err is not a twirp.Error, it will get wrapped with twirp.InternalErrorWith(err)
func WriteError(resp http.ResponseWriter, err error) {
	writeError(context.Background(), resp, err, nil)
}

// writeError writes Twirp errors in the response and triggers hooks.
func writeError(ctx context.Context, resp http.ResponseWriter, err error, hooks *twirp.ServerHooks) {
	// Non-twirp errors are wrapped as Internal (default)
	twerr, ok := err.(twirp.Error)
	if !ok {
		twerr = twirp.InternalErrorWith(err)
	}

	statusCode := twirp.ServerHTTPStatusFromErrorCode(twerr.Code())
	ctx = ctxsetters.WithStatusCode(ctx, statusCode)
	ctx = callError(ctx, hooks, twerr)

	respBody := marshalErrorToJSON(twerr)

	resp.Header().Set("Content-Type", "application/json") // Error responses are always JSON
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBody)))
	resp.WriteHeader(statusCode) // set HTTP status code and send response

	_, writeErr := resp.Write(respBody)
	if writeErr != nil {
		// We have three options here. We could log the error, call the Error
		// hook, or just silently ignore the error.
		//
		// Logging is unacceptable because we don't have a user-controlled
		// logger; writing out to stderr without permission is too rude.
		//
		// Calling the Error hook would confuse users: it would mean the Error
		// hook got called twice for one request, which is likely to lead to
		// duplicated log messages and metrics, no matter how well we document
		// the behavior.
		//
		// Silently ignoring the error is our least-bad option. It's highly
		// likely that the connection is broken and the original 'err' says
		// so anyway.
		_ = writeErr
	}

	callResponseSent(ctx, hooks)
}

// urlBase helps ensure that addr specifies a scheme. If it is unparsable
// as a URL, it returns addr unchanged.
func urlBase(addr string) string {
	// If the addr specifies a scheme, use it. If not, default to
	// http. If url.Parse fails on it, return it unchanged.
	url, err := url.Parse(addr)
	if err != nil {
		return addr
	}
	if url.Scheme == "" {
		url.Scheme = "http"
	}
	return url.String()
}

// getCustomHTTPReqHeaders retrieves a copy of any headers that are set in
// a context through the twirp.WithHTTPRequestHeaders function.
// If there are no headers set, or if they have the wrong type, nil is returned.
func getCustomHTTPReqHeaders(ctx context.Context) http.Header {
	header, ok := twirp.HTTPRequestHeaders(ctx)
	if !ok || header == nil {
		return nil
	}
	copied := make(http.Header)
	for k, vv := range header {
		if vv == nil {
			copied[k] = nil
			continue
		}
		copied[k] = make([]string, len(vv))
		copy(copied[k], vv)
	}
	return copied
}

// newRequest makes an http.Request from a client, adding common headers.
func newRequest(ctx context.Context, url string, reqBody io.Reader, contentType string) (*http.Request, error) {
	req, err := http.NewRequest("POST", url, reqBody)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if customHeader := getCustomHTTPReqHeaders(ctx); customHeader != nil {
		req.Header = customHeader
	}
	req.Header.Set("Accept", contentType)
	req.Header.Set("Content-Type", contentType)
	req.Header.Set("Twirp-Version", "v5.12.1")
	return req, nil
}

// JSON serialization for errors
type twerrJSON struct {
	Code string            `json:"code"`
	Msg  string            `json:"msg"`
	Meta map[string]string `json:"meta,omitempty"`
}

// marshalErrorToJSON returns JSON from a twirp.Error, that can be used as HTTP error response body.
// If serialization fails, it will use a descriptive Internal error instead.
func marshalErrorToJSON(twerr twirp.Error) []byte {
	// make sure that msg is not too large
	msg := twerr.Msg()
	if len(msg) > 1e6 {
		msg = msg[:1e6]
	}

	tj := twerrJSON{
		Code: string(twerr.Code()),
		Msg:  msg,
		Meta: twerr.MetaMap(),
	}

	buf, err := json.Marshal(&tj)
	if err != nil {
		buf = []byte("{\"type\": \"" + twirp.Internal + "\", \"msg\": \"There was an error but it could not be serialized into JSON\"}") // fallback
	}

	return buf
}

// errorFromResponse builds a twirp.Error from a non-200 HTTP response.
// If the response has a valid serialized Twirp error, then it's returned.
// If not, the response status code is used to generate a similar twirp
// error. See twirpErrorFromIntermediary for more info on intermediary errors.
func errorFromResponse(resp *http.Response) twirp.Error {
	statusCode := resp.StatusCode
	statusText := http.StatusText(statusCode)

	if isHTTPRedirect(statusCode) {
		// Unexpected redirect: it must be an error from an intermediary.
		// Twirp clients don't follow redirects automatically, Twirp only handles
		// POST requests, redirects should only happen on GET and HEAD requests.
		location := resp.Header.Get("Location")
		msg := fmt.Sprintf("unexpected HTTP status code %d %q received, Location=%q", statusCode, statusText, location)
		return twirpErrorFromIntermediary(statusCode, msg, location)
	}

	respBodyBytes, err := ioutil.ReadAll(resp.Body)
	if err != nil {
		return wrapInternal(err, "failed to read server error response body")
	}

	var tj twerrJSON
	dec := json.NewDecoder(bytes.NewReader(respBodyBytes))
	dec.DisallowUnknownFields()
	if err := dec.Decode(&tj); err != nil || tj.Code == "" {
		// Invalid JSON response; it must be an error from an intermediary.
		msg := fmt.Sprintf("Error from intermediary with HTTP status code %d %q", statusCode, statusText)
		return twirpErrorFromIntermediary(statusCode, msg, string(respBodyBytes))
	}

	errorCode := twirp.ErrorCode(tj.Code)
	if !twirp.IsValidErrorCode(errorCode) {
		msg := "invalid type returned from server error response: " + tj.Code
		return twirp.InternalError(msg).WithMeta("body", string(respBodyBytes))
	}

	twerr := twirp.NewError(errorCode, tj.Msg)
	for k, v := range tj.Meta {
		twerr = twerr.WithMeta(k, v)
	}
	return twerr
}

// twirpErrorFromIntermediary maps HTTP errors from non-twirp sources to twirp errors.
// The mapping is similar to gRPC: https://github.com/grpc/grpc/blob/master/doc/http-grpc-status-mapping.md.
// Returned twirp Errors have some additional metadata for inspection.
func twirpErrorFromIntermediary(status int, msg string, bodyOrLocation string) twirp.Error {
	var code twirp.ErrorCode
	if isHTTPRedirect(status) { // 3xx
		code = twirp.Internal
	} else {
		switch status {
		case 400: // Bad Request
			code = twirp.Internal
		case 401: // Unauthorized
			code = twirp.Unauthenticated
		case 403: // Forbidden
			code = twirp.PermissionDenied
		case 404: // Not Found
			code = twirp.BadRoute
		case 429, 502, 503, 504: // Too Many Requests, Bad Gateway, Service Unavailable, Gateway Timeout
			code = twirp.Unavailable
		default: // All other codes
			code = twirp.Unknown
		}
	}

	twerr := twirp.NewError(code, msg)
	twerr = twerr.WithMeta("http_error_from_intermediary", "true") // to easily know if this error was from intermediary
	twerr = twerr.WithMeta("status_code", strconv.Itoa(status))
	if isHTTPRedirect(status) {
		twerr = twerr.WithMeta("location", bodyOrLocation)
	} else {
		twerr = twerr.WithMeta("body", bodyOrLocation)
	}
	return twerr
}

func isHTTPRedirect(status int) bool {
	return status >= 300 && status <= 399
}

// wrapInternal wraps an error with a prefix as an Internal error.
// The original error cause is accessible by github.com/pkg/errors.Cause.
func wrapInternal(err error, prefix string) twirp.Error {
	return twirp.InternalErrorWith(&wrappedError{prefix: prefix, cause: err})
}

type wrappedError struct {
	prefix string
	cause  error
}

func (e *wrappedError) Error() string { return e.prefix + ": " + e.cause.Error() }
func (e *wrappedError) Unwrap() error { return e.cause } // for go1.13 + errors.Is/As
func (e *wrappedError) Cause() error  { return e.cause } // for github.com/pkg/errors

// ensurePanicResponses makes sure that rpc methods causing a panic still result in a Twirp Internal
// error response (status 500), and error hooks are properly called with the panic wrapped as an error.
// The panic is re-raised so it can be handled normally with middleware.
func ensurePanicResponses(ctx context.Context, resp http.ResponseWriter, hooks *twirp.ServerHooks) {
	if r := recover(); r != nil {
		// Wrap the panic as an error so it can be passed to error hooks.
		// The original error is accessible from error hooks, but not visible in the response.
		err := errFromPanic(r)
		twerr := &internalWithCause{msg: "Internal service panic", cause: err}
		// Actually write the error
		writeError(ctx, resp, twerr, hooks)
		// If possible, flush the error to the wire.
		f, ok := resp.(http.Flusher)
		if ok {
			f.Flush()
		}

		panic(r)
	}
}

// errFromPanic returns the typed error if the recovered panic is an error, otherwise formats as error.
func errFromPanic(p interface{}) error {
	if err, ok := p.(error); ok {
		return err
	}
	return fmt.Errorf("panic: %v", p)
}

// internalWithCause is a Twirp Internal error wrapping an original error cause,
// but the original error message is not exposed on Msg(). The original error
// can be checked with go1.13+ errors.Is/As, and also by (github.com/pkg/errors).Unwrap
type internalWithCause struct {
	msg   string
	cause error
}

func (e *internalWithCause) Unwrap() error                               { return e.cause } // for go1.13 + errors.Is/As
func (e *internalWithCause) Cause() error                                { return e.cause } // for github.com/pkg/errors
func (e *internalWithCause) Error() string                               { return e.msg + ": " + e.cause.Error() }
func (e *internalWithCause) Code() twirp.ErrorCode                       { return twirp.Internal }
func (e *internalWithCause) Msg() string                                 { return e.msg }
func (e *internalWithCause) Meta(key string) string                      { return "" }
func (e *internalWithCause) MetaMap() map[string]string                  { return nil }
func (e *internalWithCause) WithMeta(key string, val string) twirp.Error { return e }

// malformedRequestError is used when the twirp server cannot unmarshal a request
func malformedRequestError(msg string) twirp.Error {
	return twirp.NewError(twirp.Malformed, msg)
}

// badRouteError is used when the twirp server cannot route a request
func badRouteError(msg string, method, url string) twirp.Error {
	err := twirp.NewError(twirp.BadRoute, msg)
	err = err.WithMeta("twirp_invalid_route", method+" "+url)
	return err
}

// withoutRedirects makes sure that the POST request can not be redirected.
// The standard library will, by default, redirect requests (including POSTs) if it gets a 302 or
// 303 response, and also 301s in go1.8. It redirects by making a second request, changing the
// method to GET and removing the body. This produces very confusing error messages, so instead we
// set a redirect policy that always errors. This stops Go from executing the redirect.
//
// We have to be a little careful in case the user-provided http.Client has its own CheckRedirect
// policy - if so, we'll run through that policy first.
//
// Because this requires modifying the http.Client, we make a new copy of the client and return it.
func withoutRedirects(in *http.Client) *http.Client {
	copy := *in
	copy.CheckRedirect = func(req *http.Request, via []*http.Request) error {
		if in.CheckRedirect != nil {
			// Run the input's redirect if it exists, in case it has side effects, but ignore any error it
			// returns, since we want to use ErrUseLastResponse.
			err := in.CheckRedirect(req, via)
			_ = err // Silly, but this makes sure generated code passes errcheck -blank, which some people use.
		}
		return http.ErrUseLastResponse
	}
	return &copy
}

// doProtobufRequest makes a Protobuf request to the remote Twirp service.
func doProtobufRequest(ctx context.Context, client HTTPClient, hooks *twirp.ClientHooks, url string, in, out proto.Message) (_ context.Context, err error) {
	reqBodyBytes, err := proto.Marshal(in)
	if err != nil {
		return ctx, wrapInternal(err, "failed to marshal proto request")
	}
	reqBody := bytes.NewBuffer(reqBodyBytes)
	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	req, err := newRequest(ctx, url, reqBody, "application/protobuf")
	if err != nil {
		return ctx, wrapInternal(err, "could not build request")
	}
	ctx, err = callClientRequestPrepared(ctx, hooks, req)
	if err != nil {
		return ctx, err
	}

	req = req.WithContext(ctx)
	resp, err := client.Do(req)
	if err != nil {
		return ctx, wrapInternal(err, "failed to do request")
	}

	defer func() {
		cerr := resp.Body.Close()
		if err == nil && cerr != nil {
			err = wrapInternal(cerr, "failed to close response body")
		}
	}()

	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	if resp.StatusCode != 200 {
		return ctx, errorFromResponse(resp)
	}

	respBodyBytes, err := ioutil.ReadAll(resp.Body)
	if err != nil {
		return ctx, wrapInternal(err, "failed to read response body")
	}
	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	if err = proto.Unmarshal(respBodyBytes, out); err != nil {
		return ctx, wrapInternal(err, "failed to unmarshal proto response")
	}
	return ctx, nil
}

// doJSONRequest makes a JSON request to the remote Twirp service.
func doJSONRequest(ctx context.Context, client HTTPClient, hooks *twirp.ClientHooks, url string, in, out proto.Message) (_ context.Context, err error) {
	reqBody := bytes.NewBuffer(nil)
	marshaler := &jsonpb.Marshaler{OrigName: true}
	if err = marshaler.Marshal(reqBody, in); err != nil {
		return ctx, wrapInternal(err, "failed to marshal json request")
	}
	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	req, err := newRequest(ctx, url, reqBody, "application/json")
	if err != nil {
		return ctx, wrapInternal(err, "could not build request")
	}
	ctx, err = callClientRequestPrepared(ctx, hooks, req)
	if err != nil {
		return ctx, err
	}

	req = req.WithContext(ctx)
	resp, err := client.Do(req)
	if err != nil {
		return ctx, wrapInternal(err, "failed to do request")
	}

	defer func() {
		cerr := resp.Body.Close()
		if err == nil && cerr != nil {
			err = wrapInternal(cerr, "failed to close response body")
		}
	}()

	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}

	if resp.StatusCode != 200 {
		return ctx, errorFromResponse(resp)
	}

	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(resp.Body, out); err != nil {
		return ctx, wrapInternal(err, "failed to unmarshal json response")
	}
	if err = ctx.Err(); err != nil {
		return ctx, wrapInternal(err, "aborted because context was done")
	}
	return ctx, nil
}

// Call twirp.ServerHooks.RequestReceived if the hook is available
func callRequestReceived(ctx context.Context, h *twirp.ServerHooks) (context.Context, error) {
	if h == nil || h.RequestReceived == nil {
		return ctx, nil
	}
	return h.RequestReceived(ctx)
}

// Call twirp.ServerHooks.RequestRouted if the hook is available
func callRequestRouted(ctx context.Context, h *twirp.ServerHooks) (context.Context, error) {
	if h == nil || h.RequestRouted == nil {
		return ctx, nil
	}
	return h.RequestRouted(ctx)
}

// Call twirp.ServerHooks.ResponsePrepared if the hook is available
func callResponsePrepared(ctx context.Context, h *twirp.ServerHooks) context.Context {
	if h == nil || h.ResponsePrepared == nil {
		return ctx
	}
	return h.ResponsePrepared(ctx)
}

// Call twirp.ServerHooks.ResponseSent if the hook is available
func callResponseSent(ctx context.Context, h *twirp.ServerHooks) {
	if h == nil || h.ResponseSent == nil {
		return
	}
	h.ResponseSent(ctx)
}

// Call twirp.ServerHooks.Error if the hook is available
func callError(ctx context.Context, h *twirp.ServerHooks, err twirp.Error) context.Context {
	if h == nil || h.Error == nil {
		return ctx
	}
	return h.Error(ctx, err)
}

func callClientResponseReceived(ctx context.Context, h *twirp.ClientHooks) {
	if h == nil || h.ResponseReceived == nil {
		return
	}
	h.ResponseReceived(ctx)
}

func callClientRequestPrepared(ctx context.Context, h *twirp.ClientHooks, req *http.Request) (context.Context, error) {
	if h == nil || h.RequestPrepared == nil {
		return ctx, nil
	}
	return h.RequestPrepared(ctx, req)
}

func callClientError(ctx context.Context, h *twirp.ClientHooks, err twirp.Error) {
	if h == nil || h.Error == nil {
		return
	}
	h.Error(ctx, err)
}

var twirpFileDescriptor0 = []byte{
	// 633 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xbc, 0x97, 0xb1, 0x8f, 0xd3, 0x3e,
	0x14, 0xc7, 0x95, 0xdf, 0xf0, 0x1b, 0xbc, 0x61, 0x24, 0xa4, 0x2b, 0x08, 0x89, 0x05, 0xb1, 0x90,
	0x93, 0x0e, 0x66, 0x86, 0xde, 0xb5, 0x01, 0xe9, 0x7a, 0x1c, 0xd7, 0x14, 0xc4, 0x09, 0x06, 0x37,
	0x7d, 0x6d, 0x8d, 0x52, 0x3b, 0xd8, 0x2f, 0x2d, 0x30, 0x33, 0xf3, 0xb7, 0x20, 0x21, 0xb1, 0xb2,
	0x22, 0x21, 0xb1, 0xb2, 0xf2, 0x1f, 0x30, 0xb1, 0xa3, 0x34, 0x76, 0x95, 0xb6, 0xd7, 0xd0, 0x73,
	0x13, 0x96, 0x0e, 0xcd, 0xcb, 0xe7, 0xfb, 0x3e, 0x7e, 0x49, 0x9c, 0x90, 0x07, 0x91, 0x1c, 0x80,
	0xff, 0x2a, 0xd5, 0xc8, 0x85, 0x8f, 0xd3, 0x7d, 0x36, 0x79, 0x27, 0xf6, 0xc3, 0x19, 0xc7, 0x68,
	0xdc, 0x65, 0x43, 0xc0, 0xb7, 0xc7, 0x72, 0x16, 0xaa, 0x54, 0x63, 0x4f, 0x83, 0xd2, 0xe1, 0x8c,
	0xab, 0x64, 0x1f, 0xb3, 0x5f, 0x3f, 0x51, 0x12, 0x25, 0x3d, 0xc0, 0x79, 0xad, 0x1f, 0x8d, 0x99,
	0x10, 0x10, 0x4f, 0xe4, 0x00, 0x14, 0x43, 0x2e, 0x85, 0x9f, 0x1f, 0xd0, 0x73, 0x48, 0x2c, 0x67,
	0x98, 0x41, 0xd2, 0x0c, 0xd2, 0x78, 0xe8, 0x90, 0xd9, 0x67, 0x42, 0x3f, 0x12, 0x43, 0xd9, 0x1d,
	0x33, 0xc5, 0xc5, 0x28, 0x4f, 0x6f, 0xb4, 0x1d, 0x48, 0x71, 0xf1, 0x2f, 0xc3, 0xe9, 0xec, 0xc8,
	0xe9, 0x02, 0x22, 0x17, 0x23, 0x83, 0x3b, 0xf8, 0x70, 0x83, 0xec, 0x6d, 0x3c, 0x9b, 0x7e, 0xf3,
	0x48, 0xa3, 0x25, 0x86, 0x52, 0x45, 0x50, 0x3c, 0xd0, 0x01, 0xad, 0xd9, 0x08, 0x68, 0xcf, 0xbf,
	0xfc, 0x92, 0xfa, 0x9b, 0x79, 0x67, 0xf0, 0x3a, 0x05, 0x8d, 0x8d, 0xa7, 0x55, 0x63, 0x75, 0x22,
	0x85, 0x06, 0xfa, 0xd9, 0x23, 0x57, 0x5b, 0x53, 0x16, 0xa7, 0x0c, 0x61, 0x5e, 0xd4, 0x45, 0x86,
	0xa9, 0xa6, 0x27, 0x4e, 0x79, 0xeb, 0x20, 0xdb, 0xff, 0xe3, 0xca, 0x78, 0xa6, 0xf1, 0xaf, 0x1e,
	0xd9, 0x0b, 0x00, 0x8b, 0x6e, 0xa7, 0x4a, 0x26, 0xa0, 0x90, 0x83, 0xa6, 0xa1, 0x4b, 0xdc, 0x46,
	0x9c, 0x95, 0xe8, 0x55, 0x4c, 0x35, 0x2a, 0xdf, 0x3d, 0x72, 0xbd, 0x97, 0x0c, 0x18, 0x2e, 0x4d,
	0x2a, 0x54, 0xc0, 0x70, 0x02, 0x02, 0xa9, 0xd3, 0xec, 0x4b, 0x80, 0x56, 0xe7, 0x59, 0xe5, 0x5c,
	0x23, 0xf4, 0xd3, 0x23, 0xb7, 0xda, 0xd9, 0x95, 0xb7, 0x5e, 0x6c, 0x46, 0xca, 0xa5, 0xa0, 0x2f,
	0x5c, 0xe2, 0xff, 0x8a, 0xb5, 0x72, 0x2f, 0x6b, 0xa2, 0x17, 0x66, 0x76, 0x04, 0x31, 0x2c, 0x17,
	0x6a, 0xfb, 0x24, 0x71, 0x9b, 0x59, 0x09, 0x70, 0xa7, 0x99, 0x95, 0x72, 0x8d, 0xd0, 0x27, 0x8f,
	0xd0, 0xf5, 0x3a, 0xda, 0xa9, 0x26, 0xcf, 0xb6, 0x7f, 0x52, 0x15, 0xce, 0x74, 0xfd, 0xc3, 0x23,
	0x37, 0xbb, 0x80, 0x4d, 0x26, 0x5a, 0x53, 0xa6, 0xb9, 0x14, 0x47, 0x80, 0x10, 0x65, 0xbc, 0xc5,
	0x24, 0x9e, 0xbb, 0x44, 0x96, 0x33, 0xad, 0xcd, 0x79, 0x1d, 0xe8, 0x82, 0x59, 0x50, 0x83, 0x59,
	0x50, 0x9f, 0x59, 0xb0, 0x9d, 0xd9, 0x47, 0x8f, 0x5c, 0x69, 0x09, 0xd6, 0x8f, 0xa1, 0xc9, 0x84,
	0x36, 0x6f, 0x04, 0xf4, 0xd8, 0x6d, 0x83, 0x5b, 0xc1, 0xd8, 0xfe, 0x3b, 0x15, 0xd1, 0x8a, 0x37,
	0x07, 0xd7, 0xab, 0x3d, 0xbb, 0xdd, 0x1c, 0x6b, 0x9c, 0xdd, 0x6e, 0x8e, 0x0b, 0x70, 0xa6, 0xeb,
	0x2f, 0x1e, 0xb9, 0x96, 0xcf, 0xc4, 0x1e, 0x5a, 0x5c, 0x3a, 0x4f, 0xdc, 0xe7, 0xbb, 0xca, 0xb2,
	0xdd, 0x9f, 0x55, 0x89, 0x2c, 0x6c, 0xf2, 0x87, 0xd9, 0xf6, 0x72, 0xc1, 0x72, 0x39, 0x6e, 0xf2,
	0x1b, 0x71, 0x3b, 0x6d, 0xf2, 0x25, 0xd4, 0x82, 0x4a, 0xfe, 0x20, 0xab, 0x4c, 0x65, 0x23, 0x6e,
	0x27, 0x95, 0x12, 0xaa, 0x51, 0x79, 0xff, 0x1f, 0xb9, 0x1b, 0x00, 0xb6, 0xde, 0xf0, 0xec, 0x85,
	0x7b, 0xb4, 0x54, 0x1a, 0xcf, 0xf1, 0x7a, 0xcc, 0x13, 0xdd, 0x96, 0xea, 0x30, 0xcf, 0xa5, 0x63,
	0xc7, 0x6b, 0x63, 0xfb, 0x08, 0xab, 0xcc, 0xff, 0x41, 0x92, 0x59, 0x86, 0xdf, 0x1e, 0xb9, 0x13,
	0x00, 0x9e, 0x82, 0x18, 0xac, 0x9e, 0x98, 0x2f, 0x58, 0x5b, 0xc9, 0x89, 0x5d, 0x81, 0xc8, 0xb1,
	0xaf, 0xad, 0xe8, 0x56, 0x7e, 0x50, 0x6f, 0x88, 0xf1, 0xfe, 0xe5, 0x91, 0xdb, 0xa5, 0x27, 0x85,
	0xd2, 0x5a, 0xb3, 0xca, 0x1b, 0x5a, 0xb0, 0xad, 0x73, 0xbf, 0xce, 0x88, 0xdc, 0xb8, 0x79, 0xff,
	0xfc, 0xe0, 0xf2, 0x5f, 0x98, 0xfd, 0xff, 0xe7, 0x5f, 0x93, 0xf7, 0xfe, 0x04, 0x00, 0x00, 0xff,
	0xff, 0x90, 0x55, 0x9b, 0x0b, 0xa4, 0x0f, 0x00, 0x00,
}
